package org.jboss.example;

import static java.lang.System.out;

import java.util.concurrent.TimeUnit;

import javax.annotation.Resource;
import javax.enterprise.concurrent.ManagedExecutorService;
import javax.enterprise.concurrent.ManagedScheduledExecutorService;
import javax.enterprise.concurrent.ManagedThreadFactory;
import javax.ws.rs.GET;
import javax.ws.rs.Path;

@Path("concurrency")
public class Concurrency {

	@Resource
	ManagedExecutorService mes;

	@Resource
	ManagedScheduledExecutorService mses;

	@Resource
	ManagedThreadFactory mtf;
	
	public Concurrency() {
	}

	@GET
	@Path("run")
	public void runnable() {
		mes.submit(new Runnable() {
			@Override
			public void run() {
				out.println("runnable");
			}

		});
	}

	@GET
	@Path("schedule")
	public void schedule() {
		out.println("Now");
		mses.schedule(new Runnable() {
			@Override
			public void run() {
				out.println("scheduled");
			}
		}, 2000, TimeUnit.MILLISECONDS);
	}

	@GET
	@Path("thread")
	public void thread() {
		Thread t1 = mtf.newThread(new Runnable() {
			@Override
			public void run() {
				out.println("Thread 1 - started");
				try {
					for (int i = 1; i < 5; i++) {
						out.println("T1" + i);
						Thread.sleep(1000);
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				out.println("Thread 1 - stop");
			}
		});
		Thread t2 = mtf.newThread(new Runnable() {
			@Override
			public void run() {
				out.println("Thread 2 - started");
				try {
					for (int i = 1; i < 5; i++) {
						out.println("T2" + i);
						Thread.sleep(1000);
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
				out.println("Thread 2 - stop");
			}
		});
		t1.start();
		t2.start();
		try {
			t1.join();
			t2.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	
}
