package org.jboss.example.batch;

import java.util.List;

import javax.batch.api.BatchProperty;
import javax.batch.api.chunk.AbstractItemWriter;
import javax.batch.runtime.context.JobContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.jboss.example.bean.User;

@Named
public class Writer extends AbstractItemWriter {

	@Inject
	private JobContext ctx;
	
	@Inject
	@BatchProperty
	private String myProperty;
	
	@Override
	public void writeItems(List<Object> items) throws Exception {
		StringBuilder sb = new StringBuilder(ctx.getJobName() + "#" + myProperty);
		for (Object o: items) {
			sb.append("#" + ((User)o).getId());
		}
		System.out.println(sb);
	}

}
